# soubor control.tcl


proc kdEntryBox {w title text default} {
    global kdPriv
    set kdPriv(entry) $default

    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    wm protocol $w WM_DELETE_WINDOW { }
#    wm transient $w [winfo toplevel [winfo parent $w]]
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both

    # 2. Fill the top part with bitmap and message.

    label $w.msg -wraplength 3i -justify left -text $text \
	    -font -Adobe-Times-Medium-R-Normal--*-140-*-*-*-*-*-*
    pack $w.msg -in $w.top -side right -expand 1 -fill both \
	    -padx 3m 
#-pady 3m
    bind $w <Return> "set kdPriv(end) 1"

    # 3. Create an entry

    entry $w.entry -textvariable kdPriv(entry) -width 20
    $w.entry selection range 0 end
    pack $w.entry -in $w.bot -fill both

    # 4. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then center the window in the
    # display and de-iconify it.

    wm withdraw $w
    update idletasks
    set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	    - [winfo vrootx [winfo parent $w]]]
    set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	    - [winfo vrooty [winfo parent $w]]]
    wm geom $w +$x+$y
    wm deiconify $w

    # 5. Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w
    tkwait visibility $w
    focus $w.entry
    
    # 6. Wait for the user to respond, then restore the focus and
    # return the result

    tkwait variable kdPriv(end)
    destroy $w
    catch {focus $oldFocus}
    return $kdPriv(entry)
    #[$w.entry get]
}

proc kd_not_supported {} {
	tk_dialog .info "Note" "This function is not supported." "" 0 OK
}
