itcl_class kdEditor {
    public w ""
    public menu
    public id
    public name
    public can
    public style      default
    public diatype    erd
    protected diag
    protected objekty ""
    protected itemObject
    protected current
    protected deleted ""
    protected cl_class 
    protected cl_boxbeg
    protected cl_boxend
    
    constructor {config} {
	global kdGlobal
	if {$w == ""} {set w .$this}
	set diag [kdDiagram #auto -name $name -id $id]
	set menu $w.mb
	catch {destroy $w}
	toplevel $w

	makeOwnMenu
	pack [frame $w.pr -relief ridge -bd 2] -side top -fill x
	label $w.pr.l -anchor w -text "Diagram: "
	label $w.pr.n -anchor w -text $name \
		-font -*-helvetica-medium-r-*-120-*
	pack $w.pr.l $w.pr.n -side left -fill x

	frame $w.v
	pack $w.v -side left -expand yes -fill both
	makeTools $w.v
	set kdGlobal($this,tool) entita
	
	frame $w.frame
	pack $w.frame -side top -expand yes -fill both
	set can $w.frame.c
	canvas $can -relief sunken -borderwidth 2 \
		-scrollregion {-100 -100 100 100} \
		-xscrollcommand "$w.frame.hscroll set" \
		-yscrollcommand "$w.frame.vscroll set"
	scrollbar $w.frame.vscroll -command "$can yview"
	scrollbar $w.frame.hscroll -orient horiz -command "$can xview"
	pack $w.frame.vscroll -side right -fill y
	pack $w.frame.hscroll -side bottom -fill x
	pack $can -expand yes -fill both

	bind $can <Shift-2> "$can scan mark %x %y"
	bind $can <Shift-B2-Motion> "$can scan dragto %x %y"
	makeBind 

	wm title $w "Diagram -- $name"
	wm iconname $w $name
	wm minsize $w 100 100
	#mozna takovy ty skryti + deiconify
	
	#tkwait visibility $w
	#after idle $this reload
    }
    destructor {
	destroyAll [itemNames obj]
	after idle "destroy $w"
    }
    method get {com} {
	return [virtual subst $com]
    }

    method setItem {item {object ""}} {
	if {$object == ""} {
	    unset itemObject($item)
	} else {
	    set itemObject($item) $object
	}
    }
    method setVar {var {val ""}} {
	set $var $val
    }
    method toDelete id {
	lappend deleted $id
    }

    method makeBind {} {
	$can bind f_move <2> [list $this callObject %x %y \
		obj {mark $X $Y}]
	$can bind f_move <B2-Motion> [list $this callObject %x %y \
		hned {drag $X $Y}]
	$can bind f_select <3> [list $this callObject %x %y \
		obj switchSelect]
	$can bind f_edit <Control-2> [list $this callObject %x %y \
		cl_box edit]
	$can bind f_edit <Shift-2> [list $this callObject %x %y \
		cl_box modify]

	bind $can  <1> "$this newObject %x %y"
	bind $w <Control-Key-d> "$this deleteSelected"
	bind $w <q> "$this delete"

	# bind .c.frame.c <z> {puts "a:%a b:%b c:%c d:%d f:%f h:%h \
		# k:%k m:%m o:%o p:%p s:%s t:%t w:%w x:%x y:%y \
		# A:%A B:%B E:%E K:%K N:%N R:%R S:%S T:%T \
		# W:%W X:%X Y:%Y"}
    }

    method makeTools {{w .v}} {
	global kdGlobal kdOps
	set i 1
	foreach item $kdOps(diagramTools:$diatype) {
	    radiobutton $w.$i -bitmap @icons/[lindex $item 0].xbm \
		    -variable kdGlobal($this,tool) -padx 4 -pady 4\
		    -relief raised -indicator 0 -selectcolor bisque3\
		    -anchor c -value [lindex $item 1]
	    pack $w.$i -side top -fill x
	    incr i
	}
	# "1:1" "1:n" "m:n" optional  -variable druh_relace 
#	option diagramTools:erd {
#	    newbox entita entita
#	    newbox relace relace
#	    newbox atribut atribut
#	    choose cara {
#		cara_r {entita relace}
#		cara_a {entita atribut}
#	    }
#	    command vyber select
#	}
    }

    method print {} {
	# !!! zruseni selectu, ... (nejlepe vsechno prekreslit)
	seteach {x1 y1 x2 y2} [$can bbox all]
	# seteach {x1 y1 x2 y2} [$can cget -scrollregion]
	$can postscript -file [kdEntryBox .e tit Soubor ~/dipl/erd.ps] \
		-x $x1 -y $y1 -colormode color \
		-width [expr $x2-$x1] -height [expr $y2-$y1]
    }

    method center_can {} {
	global kdOps
	set box [$can bbox all]
	if {$box == ""} return
	seteach {x1 y1 x2 y2} $box
	set x [expr -($x1+$x2)/2]
	set y [expr -($y1+$y2)/2]
	#foreach o [itemNames obj] 
	foreach o [$diag getObjects] {
	    $o move $x $y 0
	}
	set coords ""
	foreach s [$can bbox all] {
	    set ss [expr abs($s)+$kdOps(delta)]
	    if {$ss < $kdOps(mindia)} { 
		set ss $kdOps(mindia) 
	    }
	    set ss [expr $ss*$s/abs($s)]
	    lappend coords $ss
	}
	$can config -scrollregion $coords
	seteach {x1 x2} [$can xview]
	$can xview moveto [expr 0.5-($x2-$x1)/2] 
	seteach {y1 y2} [$can yview]
	$can yview moveto [expr 0.5-($y2-$y1)/2] 
    }

    method itemNames tag {
	set ret ""
	foreach l [$can find withtag $tag] {
	    lappend ret $itemObject($l)
	}
	return $ret
    }

    method save_insert_new class {
	foreach ob [itemNames $class] {
	    if {[$ob get {$oid}] == 0} {
		$ob configure -oid [kdDBInsert "insert into $class \
			values( $id, '[$ob info class]', \
			[join [$ob get_vals] ", "] )"]
	    }
	}
    }   

    method save_update {class} {
	set commands ""
	foreach cl $class {
	    foreach ob [itemNames $cl] {
		# !!!
		set vars [[$ob info class] :: get_vnames]
		set obvals [$ob get_vals]
		set modif ""
		set dbvals [kdDBTuple "select [join $vars ", "] \
			from $cl \
			where oid = '[$ob get {$oid}]'"]
		set i 0
		foreach v $vars  {
		    set val [$ob info public $v -value]
		    if {[lindex $dbvals $i] != $val} {
			lappend modif "$v = [lindex $obvals $i]"
		    }
		    incr i
		}
		if {$modif != ""} {
		    append commands "update $cl set " \
			    [join $modif ", "] \
			    " where oid ='[$ob get {$oid}]' ;\n"
		}
	}   }
	return $commands
    }

    method save {} {
	global g_objekty
	#	"delete from entita where diag = $id; \n"
	save_insert_new cl_box
	save_insert_new cl_line
	save_insert_new cl_conn
	set command "begin transaction; \n"
	# !!!
	if {$deleted != ""} {
	    append command "delete from cl_box where oid = " \
		    " '[join $deleted "' or oid = '"]' ;\n"
	}
	append command [save_update {cl_box cl_line cl_conn}] \
		"end transaction;"
	#puts $command
	# !!!
	kdDBExec $command
    }

    method reload {} {
	while {[set l [$diag getObjects]] != ""} {
	    [lindex $l 0] destroy
	}
	$diag load
	foreach o [$diag getObjects] {
	    $o configure -w $can -editor $this
	    $o createImage $style
	}
	center_can
    }
    method load {} {
	array set prrr {cl_box kdBox cl_line kdLine \
		cl_conn kdConnection} 
	# !!!
	foreach cl {cl_box cl_line cl_conn} {
	    set vars [concat {class oid} [$prrr($cl) :: get_vnames]]
	    set res [kdDBExec "select [join $vars ", "] \
		    from $cl where diag = '$id'"]
	    set count [pg_result $res -numTuples]
	    set vars [lrange $vars 1 end]
	    set templ "-[join $vars { "%s" -}] \"%s\""
	    for {set i 0} {$i < $count} {incr i} {
		set tup [pg_result $res -getTuple $i]
		set class [lindex $tup 0]
		set tup [lrange $tup 1 end]
		eval $diag new $class -diag $this -w $can \
			-interactive 0 \
			[eval format {$templ} $tup]
	    }
	}
    }

    method makeOwnMenu {} {
	kdMakeMenu $menu {
	    main Diagram {
		command Re~load "$this reload"
		command Save "[$this get {$diag}] save"
		command Print "$this print"
		separator
		command Close "$this delete"
	    }
	    main Edit {
		command Cetre "$this center_can"
		command Delete "$this deleteSelected"
	    }
	    main View {
		command Zoom kd_not_supported
		cascade Style {
		    radio Normal $this,style
		    radio Compact $this,style
		}
	    }
	    main Functions {
		command "Check diagram" check_diagram
		command "Check model" check_model
		command "Generate script" "$this generate"
	    }
	    main Options {
		command Printer kd_not_supported
		command Diagram kd_not_supported
	    }
	}
    }

    method generate {} {$diag genFromTemplate tables}

    method  callObject {X Y Tag Proc} {
	set X [$can canvasx $X]
	set Y [$can canvasy $Y]
	if { $Tag == "hned" } {
	    eval $current $Proc 
	} else {
	    # !!!
	    set i [$can find closest $X $Y] 
	    if { [lsearch [$can gettags $i]  $Tag] == -1 } {
		set ob [findFirst $X $Y $Tag]
	    } else {
		set ob $itemObject($i)
		#puts "else ob: $ob"
	    }
	    if { $ob != -1 } { 
		eval $ob $Proc
		#puts "eval $ob $Proc"
	}   }   
    }

    method newObject {X Y} {
	global kdGlobal kdModel
	set class $kdGlobal($this,tool)
	set X [$can canvasx $X]
	set Y [$can canvasy $Y]
	# !!!
	if {$class != "cara" } {
	    set ob [$diag new  $class -w $can -editor $this \
		    -x $X -y $Y]
	    $ob createImage $style
	} else {
	    set cl_boxbeg [findFirst $X $Y \
		    $kdModel(lcheck,$class,begin)]
	    if {$cl_boxbeg != -1} {
		set cl_class $class
		$can create line $X $Y $X $Y -tags creating_line
		kdSaveBind $can {<1> <3> <Motion>}
		bind $can <Motion> "$this createLine_drag %x %y"
		bind $can <1> "$this createLine_next %x %y"
		bind $can <3> "$this createLine_cancel"
	    }
	}
    }
    method newLineObject coords {
	global kdModel
	set len [llength $coords]
	$cl_boxbeg intersec [swap_coords [lrange $coords \
		[expr $len-4] [expr $len-1]]] x y
	set coords [lreplace $coords [expr $len-2] \
		[expr $len-1] $x $y]
	$cl_boxend intersec [lrange $coords 0 3] X Y
	set coords [lreplace $coords 0 1 $X $Y]

	set ob [$diag new $cl_class -w $can -editor $this \
		-coords $coords -interactive 0]
	$ob createImage $style
	set cl_boxend [$diag new $kdModel(lconn,$cl_class,end) \
		-editor $this -w $can -x $X -y $Y \
		-conBox $cl_boxend -conLine $ob -ind 0]
	set cl_boxbeg [$diag new $kdModel(lconn,$cl_class,begin) \
		-editor $this -w $can -x $x -y $y \
		-conBox $cl_boxbeg -conLine $ob -ind -1]
	$ob addConn $cl_boxend
	$ob addConn $cl_boxbeg
    }
    method findFirst {x y tag} {
	set items [$can find overlapping $x $y $x $y]
	# $can find withtag current
	foreach i $items {
	    if { [lsearch [$can gettags $i] $tag] != -1 } {  
		return $itemObject($i)
	}   }
	return "-1"
    }
    
    method deleteSelected {} {
	destroyAll [itemNames selected] 
    }

    method createLine_drag {x y} {
	eval $can coords creating_line [lreplace \
		[$can coords creating_line] 0 1 \
		[$can canvasx $x] [$can canvasy $y]]
    }

    method createLine_next {x y} {
	global kdModel
	createLine_drag $x $y
	set X [$can canvasx $x]
	set Y [$can canvasy $y]
	# test end
	set cl_boxend -1
	foreach o $kdModel(lcheck,$cl_class,end) {
	    set cl_boxend [findFirst $X $Y $o]
	    if {$cl_boxend != -1} {
		break
	}   }
		    
	if {$cl_boxend == -1} {
	    eval $can coords creating_line $X $Y \
		    [$can coords creating_line]
	} else {
	    newLineObject [$can coords creating_line]
	    $can delete creating_line
	    kdRestoreBind $can {<Motion> <3> <1>}
	}   
    }

    method createLine_cancel {} {
	# cancel vertex
	set coords [$can coords creating_line]
	if { [llength $coords] > 4 } {
	    # delete second vertex
	    eval $can coords creating_line [lreplace $coords 2 3]
	} else {
	    # destroy whole line
	    kdRestoreBind $can {<Motion> <3> <1>}
	    $can delete creating_line
	}   
    }
}


